Subject: bug#30044: Emacs: Gud-mode: Debugging with gud: Window switching problem

From: Claus Fischer <[email-masked]>
Date: Tue, 9 Jan 2018 21:58:47 +0100

On Tue, Jan 09, 2018 at 08:44:01PM +0200, Eli Zaretskii wrote:
> > Date: Tue, 9 Jan 2018 13:33:11 +0100
> > From: Claus Fischer <[email-masked]>
> > 
> > A few years ago, I filed a bug about debugging unter Emacs with
> > gud and gdb.
> > 
> > The problem is that often times when a halt at a breakpoint requires
> > a source file to load, the source file replaces the *gud-something*
> > buffer, which is extremely disruptive to the work flow. One expects
> > to continue typing in gud but finds oneself instead typing into some
> > source file buffer.
> 
> How do you invoke GDB?  Is it "M-x gdb RET" or "M-x gud-gdb RET"?  I
> suggest to try the former, and if you already do that, try the command
> "M-x gdb-many-windows RET" after the debugging session starts.  I also
> suggest to start the debugger in a separate frame, and switch to the
> original frame when you want to work on your windows you had before
> starting the debugging session.

I do
  M-x gud-gdb RET
since I found the other not to work as I like; a few years ago, I
started it as M-x gdb but then something changed - I don't remember
what - and I changed to gud-gdb. What's the difference? I just tried
it, I think it's the separate i/o window, isn't it?
If so, I'll stick with gud-gdb. I want my debugging session in a
single frame, and stdio is not relevant for my programs.

I usually have many frames open, but gdb is started in just one, and
when it encounters a breakpoint, it splits the frame, and that suits
me just fine - except for it sometimes burying the gud window itself.
I don't think the behavious depends on there being multiple frames.
Is that what you are suggesting?

It's hard to reproduce, but it's annoying nevertheless. I do a lot of
work in the setting emacs - autoconf - gcc - gdb, and it's generally
very productive for work on server code.

Best regards,

Claus

-- 
Claus Fischer <[email-masked]>
http://www.clausfischer.com/